package example.tryspring.cb2_oxm;

import javax.xml.bind.annotation.XmlRootElement;

import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * データを保持するクラスです。
 * <p>
 * OXM用に、@XmlRootElementアノテーションを付加し、デフォルトコンストラクタを実装しています。
 * </p>
 */
@XmlRootElement
public class Product {

	/** 名前 */
	private String name;
	/** 金額 */
	private int price;

	public Product() {
	}

	public Product(String name, int price) {
		this.name = name;
		this.price = price;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getPrice() {
		return price;
	}

	public void setPrice(int price) {
		this.price = price;
	}

	public String toString() {
		return ToStringBuilder.reflectionToString(this);
	}

}
